* macros_exchange_variable_formats.sps.
SET MPRINT OFF.
DEFINE !convert (variables=!CHAREND("/")
		/format=!TOKENS(1)
		/stringformat= !DEFAULT('NONE') !TOKENS(1) )
*  variables = the names of the numeric or string variables to convert;
   format = the numeric format to read the string as a number 
   or the format in which to represent the numeric variable in a string;
   stringformat = the format for the new string (required when converting 
   numeric to string).
!DO !vname !IN (!variables)
!IF (!stringformat='NONE') !THEN
NUMERIC temp1234(!format).
COMPUTE temp1234=NUMBER(!vname,!format).
!ELSE
STRING temp1234(!stringformat).
COMPUTE temp1234=LTRIM(STRING(!vname,!format)).
!IFEND
APPLY DICTIONARY FROM=* 
  /SOURCE VARIABLES=!vname /TARGET VARIABLES=temp1234.
MATCH FILES FILE=* /DROP=!vname.
RENAME VARIABLE (temp1234=!vname).
!DOEND
!ENDDEFINE.

* Test the macro.
DATA LIST LIST /var1(A12) var2(A12) customer_ID(F8).
BEGIN DATA
'1,235.23' '762.00' 181254 
'5,3261.32' '1,265.85' 011618 
END DATA.
VARIABLE LABEL var1 'Account value' 
  /var2 'Recent purchase'
  / customer_ID 'Customer ID #'.
SUMMARIZE /TABLES=var1 var2 customer_ID 
  /FORMAT=LIST /CELLS=NONE.
SET MPRINT=ON PRINTBACK=ON.
!convert variables= var1 var2 / format=DOLLAR10.2.
!convert variables=customer_ID 
  /format=F8 stringformat=A8.
SET MPRINT=OFF.
SUMMARIZE /TABLES=var1 var2 customer_ID 
  /FORMAT=LIST /CELLS=NONE.
