* macros_split_file_by_cat_var_numeric.SPS.
SET MPRINT OFF.
* Initial file has category variable cat1 which has n different values.
* Objective is to create n different files.
* The syntax works for any different values of cat1.

* This creates a data file for illustration purposes.
* The categorical variable cat1 has up to 10 different values.
NEW FILE.
INPUT PROGRAM.
LOOP id=1 TO 500.
- COMPUTE cat1=TRUNC(UNIFORM(10)).
- END CASE.
END LOOP.
END FILE.
END INPUT PROGRAM.
SAVE OUTFILE='c:\temp\mydata.sav'.

* Start the job.

DEFINE !split (filevar=!TOKENS(1) /value=!TOKENS(1))
TEMPORARY.
SELECT IF (!filevar=!value).
SAVE OUTFILE=!QUOTE(!CONCAT('c:\temp\temp',!value,'.sav.')).
!ENDDEFINE.

*Find all different value of cat1 which exist.
SORT CASES BY cat1.
AGGREGATE OUTFILE=*
 /PRESORTED
 /BREAK=cat1  
 /notused = N.
FORMAT cat1(F8.0).

* Write a syntax file which will call the above macro.
WRITE OUTFILE='c:\temp\call macro.sps'
  /'!split filevar=cat1 value=' cat1 '.'.
EXECUTE.

* Get the original data file and do the macro calls.
GET FILE='c:\temp\mydata.sav'.
SET MPRINT=ON.
INSERT FILE= 'C:\temp\call macro.sps'.
